<!DOCTYPE html>


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>How to translate my app ? &mdash; Bérou 0.1 documentation</title>
    
    <link rel="stylesheet" href="../_static/basic.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    <link rel="stylesheet" href="../_static/bootstrap-3.3.4/css/bootstrap.min.css" type="text/css" />
    <link rel="stylesheet" href="../_static/bootstrap-3.3.4/css/bootstrap-theme.min.css" type="text/css" />
    <link rel="stylesheet" href="../_static/bootstrap-sphinx.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '0.1',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <script type="text/javascript" src="../_static/js/jquery-1.11.0.min.js"></script>
    <script type="text/javascript" src="../_static/js/jquery-fix.js"></script>
    <script type="text/javascript" src="../_static/bootstrap-3.3.4/js/bootstrap.min.js"></script>
    <script type="text/javascript" src="../_static/bootstrap-sphinx.js"></script>
    <link rel="top" title="Bérou 0.1 documentation" href="../index.html" />
<meta charset='utf-8'>
<meta http-equiv='X-UA-Compatible' content='IE=edge,chrome=1'>
<meta name='viewport' content='width=device-width, initial-scale=1.0, maximum-scale=1'>
<meta name="apple-mobile-web-app-capable" content="yes">

  </head>
  <body role="document">

  <div id="navbar" class="navbar navbar-default navbar-fixed-top">
    <div class="container">
      <div class="navbar-header">
        <!-- .btn-navbar is used as the toggle for collapsed navbar content -->
        <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".nav-collapse">
          <span class="icon-bar"></span>
          <span class="icon-bar"></span>
          <span class="icon-bar"></span>
        </button>
        <a class="navbar-brand" href="../index.html">
          Bérou</a>
        <span class="navbar-text navbar-version pull-left"><b>0.1</b></span>
      </div>

        <div class="collapse navbar-collapse nav-collapse">
          <ul class="nav navbar-nav">
            
            
              <li class="dropdown globaltoc-container">
  <a role="button"
     id="dLabelGlobalToc"
     data-toggle="dropdown"
     data-target="#"
     href="../index.html">Site <b class="caret"></b></a>
  <ul class="dropdown-menu globaltoc"
      role="menu"
      aria-labelledby="dLabelGlobalToc"><ul class="simple">
</ul>
</ul>
</li>
              
                <li class="dropdown">
  <a role="button"
     id="dLabelLocalToc"
     data-toggle="dropdown"
     data-target="#"
     href="#">Page <b class="caret"></b></a>
  <ul class="dropdown-menu localtoc"
      role="menu"
      aria-labelledby="dLabelLocalToc"><ul>
<li><a class="reference internal" href="#">How to translate my app ?</a><ul>
<li><a class="reference internal" href="#use-trans-in-templates">Use <cite>{% trans %}</cite> in templates</a></li>
<li><a class="reference internal" href="#use-ugettext-in-python-files">Use <cite>ugettext</cite> in python files</a></li>
<li><a class="reference internal" href="#run-makemessages-to-create-po-files">Run <cite>makemessages</cite> to create <cite>.po</cite> files</a></li>
</ul>
</li>
</ul>
</ul>
</li>
              
            
            
              
                
              
            
            
            
            
              <li class="hidden-sm">
<div id="sourcelink">
  <a href="../_sources/development/i18n.txt"
     rel="nofollow">Source</a>
</div></li>
            
          </ul>

          
            
<form class="navbar-form navbar-right" action="../search.html" method="get">
 <div class="form-group">
  <input type="text" name="q" class="form-control" placeholder="Search" />
 </div>
  <input type="hidden" name="check_keywords" value="yes" />
  <input type="hidden" name="area" value="default" />
</form>
          
        </div>
    </div>
  </div>

<div class="container">
  <div class="row">
    <div class="col-md-12">
      
  <div class="section" id="how-to-translate-my-app">
<h1>How to translate my app ?<a class="headerlink" href="#how-to-translate-my-app" title="Permalink to this headline">¶</a></h1>
<p>In order to make your app available in different languages, you need to do a few things:</p>
<p>The first things you need to do is create a <cite>locale</cite> directory in your app folder.
When the directory is create, you will need to wrap all your strings with the <cite>ugettext</cite> function.</p>
<div class="section" id="use-trans-in-templates">
<h2>Use <cite>{% trans %}</cite> in templates<a class="headerlink" href="#use-trans-in-templates" title="Permalink to this headline">¶</a></h2>
<p>In order to use the ugettext function, you need to load the <cite>i18n</cite> module. Then, you need to use the
<cite>trans</cite> templatetag with your strings as parameters.</p>
<p>Exemple:</p>
<div class="highlight-python"><div class="highlight"><pre>{% extends &#39;berou/base.html&#39; %}
{% load i18n %}
{% trans &#39;Hello world!&#39; %}
{% block content %}
{% endblock content %}
</pre></div>
</div>
</div>
<div class="section" id="use-ugettext-in-python-files">
<h2>Use <cite>ugettext</cite> in python files<a class="headerlink" href="#use-ugettext-in-python-files" title="Permalink to this headline">¶</a></h2>
<p>In <cite>views.py</cite>, you need to use ugettext, conventionally renamed to <cite>_</cite>,
and wrap your strings with it.</p>
<div class="highlight-python"><div class="highlight"><pre><span class="kn">from</span> <span class="nn">django.utils.translation</span> <span class="kn">import</span> <span class="n">ugettext</span> <span class="k">as</span> <span class="n">_</span>
<span class="kn">from</span> <span class="nn">django.views.generic</span> <span class="kn">import</span> <span class="n">TemplateView</span>

<span class="k">class</span> <span class="nc">MyView</span><span class="p">(</span><span class="n">TemplateView</span><span class="p">):</span>
    <span class="n">template_name</span> <span class="o">=</span> <span class="s">&#39;my_app/my_template.html&#39;</span>

    <span class="k">def</span> <span class="nf">get_context_data</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">):</span>
        <span class="n">context</span> <span class="o">=</span> <span class="nb">super</span><span class="p">(</span><span class="n">MyView</span><span class="p">,</span> <span class="bp">self</span><span class="p">)</span><span class="o">.</span><span class="n">get_context_data</span><span class="p">(</span><span class="o">**</span><span class="n">kwargs</span><span class="p">)</span>
        <span class="n">context</span><span class="p">[</span><span class="s">&#39;my_text&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="n">_</span><span class="p">(</span><span class="s">&#39;Hello world!&#39;</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">context</span>
</pre></div>
</div>
</div>
<div class="section" id="run-makemessages-to-create-po-files">
<h2>Run <cite>makemessages</cite> to create <cite>.po</cite> files<a class="headerlink" href="#run-makemessages-to-create-po-files" title="Permalink to this headline">¶</a></h2>
<p>When you have at least one string wrapped in a <cite>ugettext</cite> call,
you can run <cite>makemessages</cite> to create a <cite>.po</cite> file.
<cite>makemessages</cite> needs a language code in order to create the right file.</p>
<p>This is how you run it:</p>
<div class="highlight-python"><div class="highlight"><pre>django-admin makemessages -l fr
</pre></div>
</div>
<p>Run this command in your app folder. <cite>fr</cite> is for the French language.
You can replace <cite>fr</cite> with any language that you can find on the
wikipedia page related called <a class="reference external" href="http://en.wikipedia.org/wiki/List_of_ISO_639-1_codes">List of ISO 639-1 codes</a></p>
<p>When running this command, Django searches in your application for translatable strings.
It will collect all of them and will write them in a <cite>.po</cite> file.
Empty strings will also be created for you to fill in with your translation.
The result in located in <cite>locale/fr/LC_MESSAGES/django.po</cite>.</p>
<p>When you&#8217;re done translating strings, you need to compile your translations:</p>
<div class="highlight-python"><div class="highlight"><pre>./manage.py compilemessages
</pre></div>
</div>
<p>That&#8217;s it, your application is now translated.
If a french user accesses Bérou, they will get the text in French.
If HTTP requests have the <cite>accept-language</cite> header, django will use its value
in order to determine which language to use.
There is an article published on <a class="reference external" href="http://www.w3.org/International/questions/qa-accept-lang-locales">w3</a>.</p>
</div>
</div>


    </div>
      
  </div>
</div>
<footer class="footer">
  <div class="container">
    <p class="pull-right">
      <a href="#">Back to top</a>
      
    </p>
    <p>
        &copy; Copyright 2015, Francois Ribemont.<br/>
      Created using <a href="http://sphinx-doc.org/">Sphinx</a> 1.3.1.<br/>
    </p>
  </div>
</footer>
  </body>
</html>